
# Copyright (C) 1999  Jarra & Anna Voleynik
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.

#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

# dir_agent.cfg contains entries in the following format:
# DIR:<directory%sequence>:<regular expression>:<max files>:<severity> 

# point to the directory where emsg.sh wrapper for emsg1 resides
EMSGSHDIR=.  
oldIFS=$IFS 
IFS='
'
for line in `cat dir_agent.cfg  | egrep '^DIR:'` 
do
	IFS=$oldIFS

	DIRSEQ=`echo $line | cut -d: -f 2`
	DIR=`echo $DIRSEQ | cut -d% -f 1`
	PAT=`echo $line | cut -d: -f 3`
	MAX=`echo $line | cut -d: -f 4`
	NAME=`echo $line | cut -d: -f 5`
	SEV=`echo $line | cut -d: -f 6`

	olddir=`pwd`
	cd $DIR
	COUNT=`ls $PAT | wc -l | tr -d ' '`
	cd $olddir
	if [ $COUNT -gt $MAX ];then
		$EMSGSHDIR/emsg.sh $SEV /OS/DIR "$DIRSEQ $COUNT $NAME files exceeded a max of $MAX"
	fi
done



		
