
# Copyright (C) 1999  Jarra & Anna Voleynik
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.

#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

# fs_agent.cfg contains entries in the following format:
# FS:<mount point>:<min free>:<severity> 

# point to the directory where emsg.sh wrapper for emsg1 resides
EMSGSHDIR=.  
oldIFS=$IFS 
IFS='
'
for line in `cat fs_agent.cfg  | egrep '^FS:'` 
do
	IFS=$oldIFS

	MP=`echo $line | cut -d: -f 2`
	MINFREE=`echo $line | cut -d: -f 3`
	SEV=`echo $line | cut -d: -f 4`

	# get the free space available
	FS=`df $MP | grep -iv available | tr -d '%' | awk '{temp=100-$5; if(temp >=0) {print temp} else {print 0}}'`
	if [ $FS -lt $MINFREE ];then
		$EMSGSHDIR/emsg.sh $SEV /OS/FS "$MP is less than $FS"
		continue
	fi
done



		
