#!/usr/bin/perl
#
# Port and connection agent v1.0
# Copyright (C) 1999, Patric Sandelin <patric@kajen.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

use IO::Socket::INET;
use Net::Ping;

my $emsgsh = "./emsg.sh";
my $class = "/OS/CONN";
my $config = "inet_agent.cfg";
my $host;
my $port;
my $severity;
my $ping;

open(CONF, "<$config");
while(<CONF>) {
  chomp;
  if ($_ =~ /^\#/) { next; }
  ($host,$port,$severity) = split(':', $_);
  if($host eq "" | $port eq "" | $severity eq "") {
    print "All parameters in $config is not defined\n";
  } else {
    if ($port =~ /ping/) {
      $ping = Net::Ping->new("icmp");
      $alive = $ping->ping("$host");
      if ($alive) {
	next;
      } else { 
	system("$emsgsh $severity $class \"ping $host is unreachable\""); 
      }
      $ping->close();
    }

  if ($port =~ /a-zA-Z/) {
    $port = getservbyname("$port","tcp");
  }
    $sock = IO::Socket::INET->new(PeerAddr => "$host",
				  PeerPort => "$port");
    if (defined ($sock)) {
      $sock->close;
      next;
    } else {
      $portname = getservbyport("$port","tcp");
      unless ($portname) { $portname = "noname"; }
      system("$emsgsh $severity $class \"port$port\ ($portname\) is unreachable\"");
    }
  }
}
close(CONF);
