:
# Copyright (C) 1999  Jarra & Anna Voleynik
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.

#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

# directory where emsg.sh resides
EMSGSHDIR=.
# set STATFILEDIR to the directory that will store status files
STATFILEDIR=.
oldIFS=$IFS
IFS='
'
for line in `cat log_agent.cfg | egrep '^LOG:'`
do
	IFS=$oldIFS

	# log agent name
	LOGWATCHER=`echo $line | cut -d":" -f2`

	# the file to scan for pattern
	FILE=`echo $LOGWATCHER | cut -d% -f1`

	# severity
	SEV=`echo $line | cut -d":" -f5`

	# does the file exist ?
	if [ ! -f $FILE ];then
		$EMSGSHDIR/emsg.sh OS/LOG "$LOGWATCHER file to scan does not exist"
		continue # take next log agent if any
	fi

	# file to hold last byte read
	STATFILE=$STATFILEDIR/`basename $LOGWATCHER`
	if [ ! -f $STATFILE ];then
		`wc -c $FILE | awk '{print $1}'` > $STATFILE
	fi

	OLDBYTES=`cat $STATFILE`
	TOTALBYTES=`wc -c $FILE | awk '{print $1}'`

	# how many new bytes to read
	DIFF=`expr $TOTALBYTES - $OLDBYTES`
	if [ $DIFF -lt 0 ];then # file has been reset
		DIFF=`expr $DIFF \* -1` # start from byte 0
	fi
	echo "$TOTALBYTES" > $STATFILE
	if [ $DIFF -eq 0 ];then # no entries
		continue
	fi
	PATTERN=`echo $line | cut -d":" -f3`
	OUTPUTMSG=`echo $line | cut -d":" -f4`
	oldIFS=$IFS
     IFS='
'
     for MSG in `tail -c $DIFF $FILE |  sed  -n "s/$PATTERN/$OUTPUTMSG/p"`
     do
		$EMSGSHDIR/emsg.sh $SEV /OS/LOG "$LOGWATCHER $MSG"
     done
done


